#version 430 core

layout(location = 0) uniform sampler2D screenTexture;
layout(location = 1) uniform float threshold;

in vec2 fragPosition;

out vec4 fragColor;

const float offset = 1.0 / 300.0;  

void main()
{
    vec2 offsets[9] = vec2[](
        vec2(-offset,  offset), // top-left
        vec2( 0.0f,    offset), // top-center
        vec2( offset,  offset), // top-right
        vec2(-offset,  0.0f),   // center-left
        vec2( 0.0f,    0.0f),   // center-center
        vec2( offset,  0.0f),   // center-right
        vec2(-offset, -offset), // bottom-left
        vec2( 0.0f,   -offset), // bottom-center
        vec2( offset, -offset)  // bottom-right    
    );

    float kernel[9] = float[](
        1,  1,  1,
        1, -8,  1,
        1,  1,  1
    );
    
    vec3 sampleTex[9];
    for(int i = 0; i < 9; i++)
    {
        sampleTex[i] = vec3(texture(screenTexture, fragPosition.st + offsets[i]));
    }
    vec3 col = vec3(1.0);
    for(int i = 0; i < 9; i++)
    {
        col -= sampleTex[i] * kernel[i];
    }
    
    fragColor = vec4(col, 1.0);
    if(col.x > threshold && col.y > threshold && col.z > threshold) {
        fragColor = vec4(vec3(texture(screenTexture, fragPosition)), 1.0);
    } else {
        fragColor = vec4(vec3(0), 1.0);
    }
}  
